commit f89ba6e9a5da5506cb72235f500b152d4d365f3f
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Wed Nov 25 17:18:44 2020 +0000

    libstdc++: Fix missing subsumption in std::iterator_traits [PR 97935]
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/97935
            * include/bits/iterator_concepts.h (__detail::__iter_without_category):
            New helper concept.
            (__iterator_traits::__cat): Use __detail::__iter_without_category.
            * testsuite/24_iterators/associated_types/iterator.traits.cc: New test.
    
    (cherry picked from commit 9d908b7fc475b351622fa5630d4874068c789d70)

diff --git a/libstdc++-v3/include/bits/iterator_concepts.h b/libstdc++-v3/include/bits/iterator_concepts.h
index 6c63e65c888..e2ad37179be 100644
--- a/libstdc++-v3/include/bits/iterator_concepts.h
+++ b/libstdc++-v3/include/bits/iterator_concepts.h
@@ -331,6 +331,11 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 
     template<typename _Iter>
       concept __iter_without_nested_types = !__iter_with_nested_types<_Iter>;
+
+    template<typename _Iter>
+      concept __iter_without_category
+	= !requires { typename _Iter::iterator_category; };
+
   } // namespace __detail
 
   template<typename _Iterator>
@@ -370,20 +375,20 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 	{ using type = typename _Iter::iterator_category; };
 
       template<typename _Iter>
-	requires (!requires { typename _Iter::iterator_category; }
-		  && __detail::__cpp17_randacc_iterator<_Iter>)
+	requires __detail::__iter_without_category<_Iter>
+		  && __detail::__cpp17_randacc_iterator<_Iter>
 	struct __cat<_Iter>
 	{ using type = random_access_iterator_tag; };
 
       template<typename _Iter>
-	requires (!requires { typename _Iter::iterator_category; }
-		  && __detail::__cpp17_bidi_iterator<_Iter>)
+	requires __detail::__iter_without_category<_Iter>
+		  && __detail::__cpp17_bidi_iterator<_Iter>
 	struct __cat<_Iter>
 	{ using type = bidirectional_iterator_tag; };
 
       template<typename _Iter>
-	requires (!requires { typename _Iter::iterator_category; }
-		  && __detail::__cpp17_fwd_iterator<_Iter>)
+	requires __detail::__iter_without_category<_Iter>
+		  && __detail::__cpp17_fwd_iterator<_Iter>
 	struct __cat<_Iter>
 	{ using type = forward_iterator_tag; };
 
diff --git a/libstdc++-v3/testsuite/24_iterators/associated_types/iterator.traits.cc b/libstdc++-v3/testsuite/24_iterators/associated_types/iterator.traits.cc
new file mode 100644
index 00000000000..c3549fefaf6
--- /dev/null
+++ b/libstdc++-v3/testsuite/24_iterators/associated_types/iterator.traits.cc
@@ -0,0 +1,56 @@
+// Copyright (C) 2020 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// { dg-options "-std=gnu++2a" }
+// { dg-do compile { target c++2a } }
+
+#include <iterator>
+
+struct bidi_iterator
+{
+  // No nested reference and pointer types.
+  // No iterator_category.
+
+  // cpp17-iterator requirements:
+  int&           operator*() const;
+  bidi_iterator& operator++();
+  bidi_iterator  operator++(int);
+
+  // cpp17-input-iterator requirements:
+  friend bool operator==(const bidi_iterator&, const bidi_iterator&);
+  using difference_type = long long;
+  using value_type = int;
+
+  // cpp17-forward-iterator requirements:
+  bidi_iterator();
+
+  // cpp17-bidirectional-iterator requirements:
+  bidi_iterator& operator--();
+  bidi_iterator operator--(int);
+};
+
+void
+test01()
+{
+  // PR libstdc++/97935
+  // Missing subsumption in iterator category detection
+  using namespace std;
+  static_assert(__detail::__cpp17_bidi_iterator<bidi_iterator>);
+  static_assert(same_as<iterator_traits<bidi_iterator>::iterator_category,
+			bidirectional_iterator_tag>,
+		"PR libstdc++/97935");
+}

